/**********************************************************************
  VKvZX(}V\[X)̒ǉ
  $Id: create_proc.c,v 1.3 2002/08/28 17:08:49 tane Exp $
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"
#include "sim_io.h"

#define TEXT_SEG_TOP  (0x00)
#define PCIIO_SEG_TOP (0x80)
#define GVRAM_SEG_TOP (0xf0)

int	create_proc( struct PROCESS_LIST *proc_list, int memsize )
{
int id ;
struct MACHINE_RESOURCE *mres ;
int res ; 

  proc_list->cur_id++ ;
  id   = proc_list->cur_id ;
  mres = &proc_list->proc[id] ;

  if( mres->mem[TEXT_SEG_TOP]!=NULL ){
    free(mres->mem[TEXT_SEG_TOP]) ;
    mres->mem[TEXT_SEG_TOP]=NULL ;
    mres->mem_size[TEXT_SEG_TOP]=0 ;
  }

  res=memal( mres, TEXT_SEG_TOP, memsize ) ;
  if( res!=NORMAL_EXIT ){
    SYSMSG("Can not allocate memory(seg=0x%02x size=%d)\n",
	   memsize, memsize ) ;
    return(MEM_ALLOC_ERROR) ;
  }

  res=memal( mres, PCIIO_SEG_TOP, DEFAULT_PCIMEMSIZE) ;
  if( res!=NORMAL_EXIT ){
    SYSMSG("Can not allocate memory(seg=0x%02x size=%d)\n",
	   PCIIO_SEG_TOP, DEFAULT_PCIMEMSIZE ) ;
    return(MEM_ALLOC_ERROR) ;
  }
    
#ifdef SUPPORT_GRAPHIC_DEVICE
  mres->mem[GVRAM_SEG_TOP]=malloc(GRAPHIC_VRAM_WIDTH*GRAPHIC_VRAM_DEPTH*GRAPHIC_SCREEN_HEIGHT) ;
  res=memal( mres, GVRAM_SEG_TOP, (GRAPHIC_VRAM_WIDTH*GRAPHIC_VRAM_DEPTH*GRAPHIC_SCREEN_HEIGHT) ) ;
  if( res!=NORMAL_EXIT ){
    SYSMSG("Can not allocate memory(seg=0x%02x size=%d)\n",
	   GVRAM_SEG_TOP, (GRAPHIC_VRAM_WIDTH*GRAPHIC_VRAM_DEPTH*GRAPHIC_SCREEN_HEIGHT) ) ;
    return(MEM_ALLOC_ERROR) ;
  }
#endif

  init_regs( mres ) ;
  mres->heap_top      = default_heaptop ;
  mres->heap_size     = 0 ;
  mres->pc            = default_exec_start ;
  mres->GPR[1].rl     = mres->mem_size[TEXT_SEG_TOP] - default_stack_top_offset ;
  mres->id            = id ;
  strcpy(mres->pname,"init") ;

  return(NORMAL_EXIT) ;
}
