/**********************************************************************
  sim floppy (Pseudo floppyhCu)
  $Id: dev_floppy.c,v 1.1 2002/08/28 17:08:50 tane Exp $
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"
#include "op_exec.h"
#include "sim_io.h"

#define FDC03f0  0x800003f0
#define FDC03f1  0x800003f1
#define FDC03f2  0x800003f2
#define FDC03f3  0x800003f3
#define FDC03f4  0x800003f4
#define FDC03f5  0x800003f5
#define FDC03f6  0x800003f6
#define FDC03f7  0x800003f7


int dev_floppy( unsigned int port , struct MACHINE_RESOURCE *mres )
{
  if( __access_fdc==1 ){
    SYSMSG("FDC(pc:%08x,ad:%08x,%s) = %02x %02x %02x %02x %02x %02x %02x %02x\n",
	   __access_fdc_pc , __access_fdc_adrs ,
	   (__access_fdc_is_ld==1 ? "ld" : "st") ,
	   mres->mem[seg(0x800003f0)][lad(0x800003f0)],
	   mres->mem[seg(0x800003f1)][lad(0x800003f1)],
	   mres->mem[seg(0x800003f2)][lad(0x800003f2)],
	   mres->mem[seg(0x800003f3)][lad(0x800003f3)],
	   mres->mem[seg(0x800003f4)][lad(0x800003f4)],
	   mres->mem[seg(0x800003f5)][lad(0x800003f5)],
	   mres->mem[seg(0x800003f6)][lad(0x800003f6)],
	   mres->mem[seg(0x800003f7)][lad(0x800003f7)]) ;
  }
  if( mres->mem[seg(FDC03f2)][lad(FDC03f2)]==0x0c ){
    dev_pic_set_interrupt( PIC_IR06_INT ) ;
  }
  mres->mem[seg(FDC03f2)][lad(FDC03f2)]=0 ;
  return(0) ;
}


int dev_floppy_init( struct MACHINE_RESOURCE *mres )
{
  return( NORMAL_EXIT ) ;
}
