/**********************************************************************
  oCit@CsR}h
  $Id: exec_cmd.c,v 1.8 2002/08/28 17:08:51 tane Exp $
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "funcs.h"
#include "processor.h"
#include "memory.h"
#include "op_exec.h"
#include "sim_io.h"

int	exception( struct MACHINE_RESOURCE *mres , int code ) ;

int	exec_cmd( struct TOKEN_STRUCT *tk_pt , int mode )
{
struct	TOKEN_STRUCT	token ;
int	excp ;
int     id ;
int     res ;
int     ptr ;
int     i,cmdlen ;
int     arglen ;
int	break_flag ;
int     exec_mode ; 
unsigned char *cmdptr, *cmdline ; 

 break_flag=ON ;
 id=proc_list.cur_id ;

 if( (mode & GO_EXEC_MODE)!=0 ){ //VKvZXforkĎs 
   res=create_proc( &proc_list, default_memsize ) ;
   if( res != NORMAL_EXIT ){
     SYSMSG("Failed to create process\n") ;
     return( res ) ;
   }
   id=proc_list.cur_id ;
   res=elf_load(  &proc_list.proc[id], tk_pt->pt[1] ) ;
   if( res != NORMAL_EXIT ){
     remove_proc( &proc_list ) ;
     return( res ) ;
   }
   
   sim_setarg( &proc_list.proc[id], tk_pt, 1 ) ;
   if( res != NORMAL_EXIT ){
     remove_proc( &proc_list ) ;
     return( res ) ;
   }
   do{
     int i ;
     int leng ;
     for( i=0 ; i<PNAME_LEN ; i++ ) proc_list.proc[id].pname[i]='\0' ;
     leng=strlen(tk_pt->pt[1])+1 ;
     if( leng>=PNAME_LEN ) leng=PNAME_LEN ;
     strncpy( proc_list.proc[id].pname, tk_pt->pt[1], leng ) ;
   } while(0) ;
   
   iexe_count  = 0 ;
   break_flag=OFF ;
 }
   
 set_sighandl_ppcsim() ;
 while ( -1 ) {
   exec_mode=EXEC_INST ;
   
   if( sig_int != 0 ) break ;

   trace.buf[trace.ptr].pc   = proc_list.proc[id].pc ;
   trace.buf[trace.ptr].inst = proc_list.proc[id].inst ;
   trace.ptr=(trace.ptr+1)%trace.size ;
   
   iexe_count++ ;
   
   if( trace_stat!=TRACE_OFF ){
     exec_mode |= EXEC_DIS ;
     switch( trace_stat ){
     case TRACE_GRP : 
       print_regs( &proc_list.proc[id], PRINT_GPR_AND_OTHERS ) ;
       break ;
     case TRACE_ALL :
       print_regs( &proc_list.proc[id], PRINT_ALLREGISTERS ) ;
       break ;
     default :
     }
   }
   
   if( proc_list.proc[id].bp_num > 0 ){
     for( i=0 ; i<proc_list.proc[id].bp_num ; i++ ){
       if( proc_list.proc[id].pc==proc_list.proc[id].bp[i].ad ){
   	 if( break_flag==ON ){ //break|CgŎ~܂ĊJɂ܂Ȃlɂ
   	   break ;
   	 }else{
   	   SYSMSG("Exec stop by break point.\n") ;
	   op_exec(&proc_list.proc[id],EXEC_DIS) ;
   	   return(NORMAL_EXIT) ;     
   	 }
       }
     }
     break_flag=OFF ;
   }
   
   if( proc_list.proc[id].pp_num > 0 ){
     for( i=0 ; i<proc_list.proc[id].pp_num ; i++ ){
       if( proc_list.proc[id].pc==proc_list.proc[id].pp[i].ad ){
   	 SYSMSG("Passed count= ") ;
	 SYSMSGLL(iexe_count,0) ;
	 SYSMSG("\n") ;
   	 switch( pp_msg ){
   	 case PP_DUMP_PC :
	   exec_mode |= EXEC_DIS ;
   	   break ;
   	 case PP_DUMP_GPR :
   	   print_regs( &proc_list.proc[id], PRINT_GPR_AND_OTHERS ) ;
   	   break ;
   	 case PP_DUMP_ALL :
   	   print_regs( &proc_list.proc[id], PRINT_ALLREGISTERS ) ;
   	   break ;
   	 default :
   	 }
   	 break ;
       }
     }
   }
   
   excp = op_exec( &proc_list.proc[id], exec_mode ) ;
   sim_io( &proc_list.proc[id] ) ;
   
   if( excp !=0 ){
     switch( excp ){
     case SYSCALLED_EXIT :
       SYSMSG("called exit.\n") ;
       remove_proc( &proc_list ) ;
       id=proc_list.cur_id ;
       if( id==0 ) return(NORMAL_EXIT) ;
       proc_list.proc[id].GPR[3].rl= 1 ;
       break ;
     case SYSCALLED_FORK :
       proc_list.proc[id].GPR[3].rl= 1 ; /** return value of parent process */
       sim_fork( &proc_list ) ;
       id=proc_list.cur_id ;
       proc_list.proc[id].GPR[3].rl= 0 ; /** return value of child process */
       proc_list.proc[id].id       = id ;
       SYSMSG("forked process.\n") ;
       break ;
     case SYSCALLED_EXECVE :
       /** R}h̎荞 fBNgpX菜 **/
       cmdlen=strlen(&proc_list.proc[id].mem[seg(proc_list.proc[id].GPR[3].rl)][lad(proc_list.proc[id].GPR[3].rl)]) ;
       cmdptr=NULL ;
       arglen=0 ;
       for( i=cmdlen-1 ; i>-1 ; i-- ){
	 cmdptr=&proc_list.proc[id].mem[seg(proc_list.proc[id].GPR[3].rl+i)][lad(proc_list.proc[id].GPR[3].rl+i)] ;
	 if( *cmdptr=='/' ){
	   cmdptr++ ;
	   break ;
	 }
       }
       arglen+=strlen(cmdptr)+1 ;
       //SYSMSG("execve %s", cmdptr ) ;
       
       /** ̎荞 **/
       for( i=0 ; ; i+=4 ){
	 ptr =proc_list.proc[id].mem[seg(proc_list.proc[id].GPR[4].rl+i+0)][lad(proc_list.proc[id].GPR[4].rl+i+0)]*0x01000000 ;
	 ptr|=proc_list.proc[id].mem[seg(proc_list.proc[id].GPR[4].rl+i+1)][lad(proc_list.proc[id].GPR[4].rl+i+1)]*0x00010000 ;
	 ptr|=proc_list.proc[id].mem[seg(proc_list.proc[id].GPR[4].rl+i+2)][lad(proc_list.proc[id].GPR[4].rl+i+2)]*0x00000100 ;
	 ptr|=proc_list.proc[id].mem[seg(proc_list.proc[id].GPR[4].rl+i+3)][lad(proc_list.proc[id].GPR[4].rl+i+3)]*0x00000001 ;
	 if( ptr==0x00000000 ) break ;
	 arglen+=strlen(&proc_list.proc[id].mem[seg(ptr)][lad(ptr)])+1 ;
	 //SYSMSG(" %s", &proc_list.proc[id].mem[ ptr ] ) ;
       }
       //SYSMSG("  : %d\n",arglen) ;
       
       cmdline=malloc(arglen+2) ;
       cmdline[0]='\0' ;
       strcat( cmdline, cmdptr ) ;
       strcat( cmdline, " " ) ;
       for( i=0,arglen=0 ; ; i+=4 ){ //Ȃ񂩏璷....(^_^;;;
	 ptr =proc_list.proc[id].mem[seg(proc_list.proc[id].GPR[4].rl+i+0)][lad(proc_list.proc[id].GPR[4].rl+i+0)]*0x01000000 ;
	 ptr|=proc_list.proc[id].mem[seg(proc_list.proc[id].GPR[4].rl+i+1)][lad(proc_list.proc[id].GPR[4].rl+i+1)]*0x00010000 ;
	 ptr|=proc_list.proc[id].mem[seg(proc_list.proc[id].GPR[4].rl+i+2)][lad(proc_list.proc[id].GPR[4].rl+i+2)]*0x00000100 ;
	 ptr|=proc_list.proc[id].mem[seg(proc_list.proc[id].GPR[4].rl+i+3)][lad(proc_list.proc[id].GPR[4].rl+i+3)]*0x00000001 ;
	 if( ptr==0x00000000 ) break ;
	 strcat( cmdline, &proc_list.proc[id].mem[seg(ptr)][lad(ptr)] ) ;
	 strcat( cmdline, " " ) ;
       }
       get_token( cmdline , &token ) ;
       
       init_regs( &proc_list.proc[id] ) ;
       proc_list.proc[id].heap_top = default_heaptop ;
       proc_list.proc[id].heap_size= 0 ;
       proc_list.proc[id].pc       = default_exec_start ;
       proc_list.proc[id].GPR[1].rl= proc_list.proc[id].mem_size[0] - default_stack_top_offset ;

       res=elf_load(  &proc_list.proc[id], cmdptr ) ;
       if( res != NORMAL_EXIT ) return( res ) ;
       sim_setarg( &proc_list.proc[id], &token, 0 ) ;
       if( res != NORMAL_EXIT ) return( res ) ;
       do{
	 int i ;
	 int leng ;
	 for( i=0 ; i<PNAME_LEN ; i++ ) proc_list.proc[id].pname[i]='\0' ;
	 leng=strlen(cmdline)+1 ;
	 if( leng>=PNAME_LEN ) leng=PNAME_LEN ;
	 strncpy( proc_list.proc[id].pname, cmdline, leng ) ;
       } while(0) ;
       free( cmdline ) ;
       break ;

     default :
       excp=exception( &proc_list.proc[id], excp ) ;
       if( excp!=0 ) return(NORMAL_EXIT) ;
     }
   }
 }
 return(NORMAL_EXIT) ;
}


