/**********************************************************************
  ߃fR[h  bit0-5=0b00xxxx
  $Id: op_0x_func.c,v 1.4 2002/08/28 17:08:51 tane Exp $
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"
#include "op_exec.h"

int op_03_func( struct MACHINE_RESOURCE *mres , int mode )  /* twi */
{
  unsigned int	r1 ;
  unsigned int	r2 ;
  int           simm ;
  unsigned int  uimm ;
  
  r1   = (mres->inst & 0x03e00000)>>21 ;
  r2   = (mres->inst & 0x001f0000)>>16 ;
  uimm = (mres->inst & 0x0000ffff) ;
  simm = uimm ;
  if( (uimm & 0x00008000)!=0 ) simm=uimm | 0xffff0000 ; //g
  
  if( DO_EXEC_DIS(mode) ){
    SYSMSG("\t%d, %%r%d, %d\n",r1,r2,simm) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( ((r1 & 0x10)!=0 && (mres->GPR[r2].rl< simm)) ||
	((r1 & 0x08)!=0 && (mres->GPR[r2].rl> simm)) ||
	((r1 & 0x04)!=0 && (mres->GPR[r2].rl==simm)) ||
	((r1 & 0x02)!=0 && (mres->GPR[r2].rl> uimm)) ||
	((r1 & 0x01)!=0 && (mres->GPR[r2].rl< uimm)) )
      return( EXCEPTION_PROGRAM ) ;
    mres->pc+=4 ;
  }
  
  return(0) ;
}

int op_07_func( struct MACHINE_RESOURCE *mres , int mode )  /* mulli */
{
  unsigned int	r1 ;
  unsigned int	r2 ;
  int           simm ;
  
  r1   = (mres->inst & 0x03e00000)>>21 ;
  r2   = (mres->inst & 0x001f0000)>>16 ;
  simm = (mres->inst & 0x0000ffff) ;
  if( (simm & 0x00008000)!=0 ) simm=simm | 0xffff0000 ; //g
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_rri(r1,r2,simm) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    mres->GPR[r1].rl=mres->GPR[r2].rl*simm ;
    mres->pc+=4 ;
  }
  
  return(0) ;
}

int op_08_func( struct MACHINE_RESOURCE *mres , int mode )  /* subfic */
{
  unsigned int	r1 ;
  unsigned int	r2 ;
  int           simm ;

  unsigned int tmpui0,tmpui1,tmpui2,bit32c ;

  r1   = (mres->inst & 0x03e00000)>>21 ;
  r2   = (mres->inst & 0x001f0000)>>16 ;
  simm = (mres->inst & 0x0000ffff) ;
  if( (simm & 0x00008000)!=0 ) simm=simm | 0xffff0000 ; //g

  if( DO_EXEC_DIS(mode) ){
    dis_print_rri(r1,r2,simm) ;
  }

  if( DO_EXEC_INST(mode) ){
    bit32c=((~mres->GPR[r2].rl & 0x00000001)+
	    (simm & 0x00000001)+1)>>1 ;
    tmpui1=~mres->GPR[r2].rl>>1 ;
    tmpui2=((unsigned int)simm)>>1 ;
    tmpui0=tmpui1+tmpui2+bit32c ;
    if( (tmpui0&0x80000000)!=0 ) mres->FLGR.xer |= 0x20000000 ;
    else                         mres->FLGR.xer &=~0x20000000 ;
    mres->GPR[r1].rl= -mres->GPR[r2].rl + simm ;
    
    mres->pc+=4 ;
  }
  
  return(0) ;
}

int op_0a_func( struct MACHINE_RESOURCE *mres , int mode )  /* cmpli */
{
  unsigned int	r2 ;
  unsigned int	cr ;
  unsigned int  uimm ;

  r2   = (mres->inst & 0x001f0000)>>16 ;
  cr   = (mres->inst & 0x03800000)>>23 ;
  uimm = (mres->inst & 0x0000ffff) ;

  if( DO_EXEC_DIS(mode) ){
    dis_print_crri(cr,r2,uimm) ;
  }

  if( DO_EXEC_INST(mode) ){
    if( mres->GPR[r2].rl==uimm )           mres->FLGR.cr[cr] |= 0x20000000 ;
    else                                   mres->FLGR.cr[cr] &=~0x20000000 ;
    if( mres->GPR[r2].rl> uimm )           mres->FLGR.cr[cr] |= 0x40000000 ;
    else                                   mres->FLGR.cr[cr] &=~0x40000000 ;
    if( mres->GPR[r2].rl< uimm )           mres->FLGR.cr[cr] |= 0x80000000 ;
    else                                   mres->FLGR.cr[cr] &=~0x80000000 ;
    if( (mres->FLGR.xer & 0x80000000)!=0 ) mres->FLGR.cr[cr] |= 0x10000000 ;
    else                                   mres->FLGR.cr[cr] &=~0x10000000 ;

    mres->pc+=4 ;
  }
  
  return(0) ;
}

int op_0b_func( struct MACHINE_RESOURCE *mres , int mode )  /* cmpi */
{
  unsigned int	r2 ;
  unsigned int	cr ;
  int           simm ;

  r2   = (mres->inst & 0x001f0000)>>16 ;
  cr   = (mres->inst & 0x03800000)>>23 ;
  simm = (mres->inst & 0x0000ffff) ;
  if( (simm & 0x00008000)!=0 ) simm=simm | 0xffff0000 ; //g

  if( DO_EXEC_DIS(mode) ){
    dis_print_crri(cr,r2,simm) ;
  }

  if( DO_EXEC_INST(mode) ){
    if( (int)mres->GPR[r2].rl==simm )      mres->FLGR.cr[cr] |= 0x20000000 ;
    else                                   mres->FLGR.cr[cr] &=~0x20000000 ;
    if( (int)mres->GPR[r2].rl> simm )      mres->FLGR.cr[cr] |= 0x40000000 ;
    else                                   mres->FLGR.cr[cr] &=~0x40000000 ;
    if( (int)mres->GPR[r2].rl< simm )      mres->FLGR.cr[cr] |= 0x80000000 ;
    else                                   mres->FLGR.cr[cr] &=~0x80000000 ;
    if( (mres->FLGR.xer & 0x80000000)!=0 ) mres->FLGR.cr[cr] |= 0x10000000 ;
    else                                   mres->FLGR.cr[cr] &=~0x10000000 ;

    mres->pc+=4 ;
  }
  
  return(0) ;
}

int op_0c_func( struct MACHINE_RESOURCE *mres , int mode )  /* addic */
{
  unsigned int	r1 ;
  unsigned int	r2 ;
  int           simm ;
  unsigned int tmpui0,tmpui1,tmpui2,bit32c ;
   
  r1   = (mres->inst & 0x03e00000)>>21 ;
  r2   = (mres->inst & 0x001f0000)>>16 ;
  simm = (mres->inst & 0x0000ffff) ;
  if( (simm & 0x00008000)!=0 ) simm=simm | 0xffff0000 ; //g

  if( DO_EXEC_DIS(mode) ){
    dis_print_rri(r1,r2,simm) ;
  }

  if( DO_EXEC_INST(mode) ){
    bit32c=((mres->GPR[r2].rl & 0x00000001)+
	    (simm & 0x00000001))>>1 ;
    tmpui1=mres->GPR[r2].rl>>1 ;
    tmpui2=((unsigned int)simm)>>1 ;
    tmpui0=tmpui1+tmpui2+bit32c ;
    if( (tmpui0&0x80000000)!=0 ) mres->FLGR.xer |= 0x20000000 ;
    else                         mres->FLGR.xer &=~0x20000000 ;
    mres->GPR[r1].rl=mres->GPR[r2].rl+simm ;
    
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_0d_func( struct MACHINE_RESOURCE *mres , int mode )  /* addic. */
{
  unsigned int	r1 ;
  unsigned int	r2 ;
  int           simm ;
  unsigned int tmpui0,tmpui1,tmpui2,bit32c ;
   
  r1   = (mres->inst & 0x03e00000)>>21 ;
  r2   = (mres->inst & 0x001f0000)>>16 ;
  simm = (mres->inst & 0x0000ffff) ;
  if( (simm & 0x00008000)!=0 ) simm=simm | 0xffff0000 ; //g

  if( DO_EXEC_DIS(mode) ){
    dis_print_rri(r1,r2,simm) ;
  }

  if( DO_EXEC_INST(mode) ){
    bit32c=((mres->GPR[r2].rl & 0x00000001)+
	    (simm & 0x00000001))>>1 ;
    tmpui1=mres->GPR[r2].rl>>1 ;
    tmpui2=((unsigned int)simm)>>1 ;
    tmpui0=tmpui1+tmpui2+bit32c ;
    if( (tmpui0&0x80000000)!=0 ) mres->FLGR.xer |= 0x20000000 ;
    else                         mres->FLGR.xer &=~0x20000000 ;
    mres->GPR[r1].rl=mres->GPR[r2].rl+simm ;
    update_cr( mres->GPR[r1].rl ) ;
    
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_0e_func( struct MACHINE_RESOURCE *mres , int mode )  /* addi */
{
  unsigned int	r1 ;
  unsigned int	r2 ;
  int           simm ;
  unsigned int	rd ;
   
  r1   = (mres->inst & 0x03e00000)>>21 ;
  r2   = (mres->inst & 0x001f0000)>>16 ;
  simm = (mres->inst & 0x0000ffff) ;
  if( (simm & 0x00008000)!=0 ) simm=simm | 0xffff0000 ; //g
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_rri(r1,r2,simm) ;
  }

  if( DO_EXEC_INST(mode) ){
    rd=simm ;
    if( r2!=0 ) rd=mres->GPR[r2].rl+rd ;
    mres->GPR[r1].rl=rd ;
    
    mres->pc+=4 ;
  }
  
  return(0) ;
}

int op_0f_func( struct MACHINE_RESOURCE *mres , int mode )  /* addis */
{
  unsigned int	r1 ;
  unsigned int	r2 ;
  int           simm ;
  unsigned int	rd ;
   
  r1   = (mres->inst & 0x03e00000)>>21 ;
  r2   = (mres->inst & 0x001f0000)>>16 ;
  simm = (mres->inst & 0x0000ffff)<<16 ;
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_rri(r1,r2,simm) ;
  }

  if( DO_EXEC_INST(mode) ){
    rd=simm ;
    if( r2!=0 ) rd=mres->GPR[r2].rl+rd ;
    mres->GPR[r1].rl=rd ;

    mres->pc+=4 ;
  }
  
  return(0) ;
}

