/**********************************************************************
  ߎs(1st decode)
  $Id: op_exec.c,v 1.5 2002/08/28 17:08:52 tane Exp $
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"
#include "op_exec.h"

int op_unknown_func( struct MACHINE_RESOURCE *mres , int mode )  /* unknown */
{
  if( DO_EXEC_DIS(mode) ){
    SYSMSG("\tunknown_instruction\n") ;
  }
  if( DO_EXEC_INST(mode) ){
    return(UNKNOWN_INSTRUCTION) ;
  }
  return(0) ;
}

int init_op_func_tbl()
{
  int i ;
  
  for( i=0 ; i<TBL_SIZE_bit00to05 ; i++ ){
    op_func_tbl[i].func =op_unknown_func ;
    op_func_tbl[i].count=0 ;
    op_func_tbl[i].name ="" ;
  }
  op_func_tbl[0x03].func=op_03_func ; op_func_tbl[0x03].name="twi"           ; /* twi */
  op_func_tbl[0x07].func=op_07_func ; op_func_tbl[0x07].name="mulli"         ; /* mulli */
  op_func_tbl[0x08].func=op_08_func ; op_func_tbl[0x08].name="subfic"        ; /* subfic */
  op_func_tbl[0x0a].func=op_0a_func ; op_func_tbl[0x0a].name="cmpli"         ; /* cmpli */
  op_func_tbl[0x0b].func=op_0b_func ; op_func_tbl[0x0b].name="cmpi"          ; /* cmpi */
  op_func_tbl[0x0c].func=op_0c_func ; op_func_tbl[0x0c].name="addic"         ; /* addic */
  op_func_tbl[0x0d].func=op_0d_func ; op_func_tbl[0x0d].name="addic."        ; /* addic. */
  op_func_tbl[0x0e].func=op_0e_func ; op_func_tbl[0x0e].name="addi"          ; /* addi */
  op_func_tbl[0x0f].func=op_0f_func ; op_func_tbl[0x0f].name="addis"         ; /* addis */
  
  op_func_tbl[0x10].func=op_10_func ; op_func_tbl[0x10].name="bc"            ; /* bc,bca,bcl,bcla */
  op_func_tbl[0x11].func=op_11_func ; op_func_tbl[0x11].name="sc"            ; /* sc */
  op_func_tbl[0x12].func=op_12_func ; op_func_tbl[0x12].name="b"             ; /* b,ba,bl,bla */
  op_func_tbl[0x13].func=op_13_func ;
  op_func_tbl[0x14].func=op_14_func ; op_func_tbl[0x14].name="rlwimi"        ; /* rlwimi,rlwimi. */
  op_func_tbl[0x15].func=op_15_func ; op_func_tbl[0x15].name="rlwinm"        ; /* rlwinm,rlwinm. */
  op_func_tbl[0x17].func=op_17_func ; op_func_tbl[0x17].name="rlwnm"         ; /* rlwnm,rlwnm. */
  op_func_tbl[0x18].func=op_18_func ; op_func_tbl[0x18].name="ori"           ; /* ori */
  op_func_tbl[0x19].func=op_19_func ; op_func_tbl[0x19].name="oris"          ; /* oris */
  op_func_tbl[0x1a].func=op_1a_func ; op_func_tbl[0x1a].name="xori"          ; /* xori */
  op_func_tbl[0x1b].func=op_1b_func ; op_func_tbl[0x1b].name="xoris"         ; /* xoris */
  op_func_tbl[0x1c].func=op_1c_func ; op_func_tbl[0x1c].name="andi."         ; /* andi. */
  op_func_tbl[0x1d].func=op_1d_func ; op_func_tbl[0x1d].name="andis."        ; /* andis. */
  op_func_tbl[0x1f].func=op_1f_func ;
  
  op_func_tbl[0x20].func=op_20_func ; op_func_tbl[0x20].name="lwz"           ; /* lwz */
  op_func_tbl[0x21].func=op_21_func ; op_func_tbl[0x21].name="lwzu"          ; /* lwzu */
  op_func_tbl[0x22].func=op_22_func ; op_func_tbl[0x22].name="lbz"           ; /* lbz */
  op_func_tbl[0x23].func=op_23_func ; op_func_tbl[0x23].name="lbzu"          ; /* lbzu */
  op_func_tbl[0x24].func=op_24_func ; op_func_tbl[0x24].name="stw"           ; /* stw */
  op_func_tbl[0x25].func=op_25_func ; op_func_tbl[0x25].name="stwu"          ; /* stwu */
  op_func_tbl[0x26].func=op_26_func ; op_func_tbl[0x26].name="stb"           ; /* stb */
  op_func_tbl[0x27].func=op_27_func ; op_func_tbl[0x27].name="stbu"          ; /* stbu */
  op_func_tbl[0x28].func=op_28_func ; op_func_tbl[0x28].name="lhz"           ; /* lhz */
  op_func_tbl[0x29].func=op_29_func ; op_func_tbl[0x29].name="lhzu"          ; /* lhzu */
  op_func_tbl[0x2a].func=op_2a_func ; op_func_tbl[0x2a].name="lha"           ; /* lha */
  op_func_tbl[0x2b].func=op_2b_func ; op_func_tbl[0x2b].name="lhau"          ; /* lhau */
  op_func_tbl[0x2c].func=op_2c_func ; op_func_tbl[0x2c].name="sth"           ; /* sth */
  op_func_tbl[0x2d].func=op_2d_func ; op_func_tbl[0x2d].name="stbu"          ; /* stbu */
  op_func_tbl[0x2e].func=op_2e_func ; op_func_tbl[0x2e].name="lmw"           ; /* lmw */
  op_func_tbl[0x2f].func=op_2f_func ; op_func_tbl[0x2f].name="stmw"          ; /* stmw */
  
  op_func_tbl[0x30].func=op_30_func ; op_func_tbl[0x30].name="lfs"           ; /* lfs */
  op_func_tbl[0x31].func=op_31_func ; op_func_tbl[0x31].name="lfsu"          ; /* lfsu */
  op_func_tbl[0x32].func=op_32_func ; op_func_tbl[0x32].name="lfd"           ; /* lfd */
  op_func_tbl[0x33].func=op_33_func ; op_func_tbl[0x33].name="lfdu"          ; /* lfdu */
  op_func_tbl[0x34].func=op_34_func ; op_func_tbl[0x34].name="stfs"          ; /* stfs */
  op_func_tbl[0x35].func=op_35_func ; op_func_tbl[0x35].name="stfsu"         ; /* stfsu */
  op_func_tbl[0x36].func=op_36_func ; op_func_tbl[0x36].name="stfd"          ; /* stfd */
  op_func_tbl[0x37].func=op_37_func ; op_func_tbl[0x37].name="stfdu"         ; /* stfdu */
  op_func_tbl[0x3b].func=op_3b_func ;                                        ; /* 3b */
  op_func_tbl[0x3f].func=op_3f_func ;                                        ; /* 3f */

  /*** 0x4cn Tu߃Zbg *****************/
  for( i=0 ; i<TBL_SIZE_bit21to30 ; i++ ){
    op_13_subfunc_tbl[i].func =op_unknown_func ;
    op_13_subfunc_tbl[i].count=0 ;
    op_13_subfunc_tbl[i].name ="" ;
  }
  op_13_subfunc_tbl[0x000].func=op_13_000_func ; op_13_subfunc_tbl[0x000].name="mcrf"          ; /* mcrf        */
  op_13_subfunc_tbl[0x010].func=op_13_010_func ; op_13_subfunc_tbl[0x010].name="bclrx"         ; /* bclrx       */
  op_13_subfunc_tbl[0x021].func=op_13_021_func ; op_13_subfunc_tbl[0x021].name="crnor"         ; /* crnor       */
  op_13_subfunc_tbl[0x032].func=op_13_032_func ; op_13_subfunc_tbl[0x032].name="rfi"           ; /* rfi         */
  op_13_subfunc_tbl[0x081].func=op_13_081_func ; op_13_subfunc_tbl[0x081].name="crandc"        ; /* crandc      */
  op_13_subfunc_tbl[0x096].func=op_13_096_func ; op_13_subfunc_tbl[0x096].name="isync"         ; /* isync       */
  op_13_subfunc_tbl[0x0c1].func=op_13_0c1_func ; op_13_subfunc_tbl[0x0c1].name="crxor"         ; /* crxor       */
  op_13_subfunc_tbl[0x0e1].func=op_13_0e1_func ; op_13_subfunc_tbl[0x0e1].name="crnand"        ; /* crnand      */
  op_13_subfunc_tbl[0x101].func=op_13_101_func ; op_13_subfunc_tbl[0x101].name="crand"         ; /* crand       */
  op_13_subfunc_tbl[0x121].func=op_13_121_func ; op_13_subfunc_tbl[0x121].name="creqv"         ; /* creqv       */
  op_13_subfunc_tbl[0x1a1].func=op_13_1a1_func ; op_13_subfunc_tbl[0x1a1].name="crorc"         ; /* crorc       */
  op_13_subfunc_tbl[0x1c1].func=op_13_1c1_func ; op_13_subfunc_tbl[0x1c1].name="cror"          ; /* cror        */
  op_13_subfunc_tbl[0x210].func=op_13_210_func ; op_13_subfunc_tbl[0x210].name="bcctrx"        ; /* bcctrx      */

  /*** 0x7cn Tu߃Zbg *****************/
  for( i=0 ; i<TBL_SIZE_bit21to30 ; i++ ){
    op_1f_subfunc_tbl[i].func =op_unknown_func ;
    op_1f_subfunc_tbl[i].count=0 ;
    op_1f_subfunc_tbl[i].name ="" ;
  }
  op_1f_subfunc_tbl[0x000].func=op_1f_000_func ; op_1f_subfunc_tbl[0x000].name="cmp"           ; /*cmp          */
  op_1f_subfunc_tbl[0x004].func=op_1f_004_func ; op_1f_subfunc_tbl[0x004].name="tw"            ; /*tw           */
  op_1f_subfunc_tbl[0x008].func=op_1f_008_func ; op_1f_subfunc_tbl[0x008].name="subfcx"        ; /*subfcx       */
  op_1f_subfunc_tbl[0x00a].func=op_1f_00a_func ; op_1f_subfunc_tbl[0x00a].name="addc"          ; /*addcx        */
  op_1f_subfunc_tbl[0x00b].func=op_1f_00b_func ; op_1f_subfunc_tbl[0x00b].name="mulhwu"        ; /*mulhwux      */
  op_1f_subfunc_tbl[0x013].func=op_1f_013_func ; op_1f_subfunc_tbl[0x013].name="mfcr"          ; /*mfcr         */
  op_1f_subfunc_tbl[0x014].func=op_1f_014_func ; op_1f_subfunc_tbl[0x014].name="lwarx"         ; /*lwarx        */
  op_1f_subfunc_tbl[0x017].func=op_1f_017_func ; op_1f_subfunc_tbl[0x017].name="lwzx"          ; /*lwzx         */
  op_1f_subfunc_tbl[0x018].func=op_1f_018_func ; op_1f_subfunc_tbl[0x018].name="slw"           ; /*slwx         */
  op_1f_subfunc_tbl[0x01a].func=op_1f_01a_func ; op_1f_subfunc_tbl[0x01a].name="cntlzw"        ; /*cntlzwx      */
  op_1f_subfunc_tbl[0x01c].func=op_1f_01c_func ; op_1f_subfunc_tbl[0x01c].name="and"           ; /*andx         */
  op_1f_subfunc_tbl[0x020].func=op_1f_020_func ; op_1f_subfunc_tbl[0x020].name="cmpl"          ; /*cmpl         */
  op_1f_subfunc_tbl[0x028].func=op_1f_028_func ; op_1f_subfunc_tbl[0x028].name="subf"          ; /*subfx        */
  op_1f_subfunc_tbl[0x036].func=op_1f_036_func ; op_1f_subfunc_tbl[0x036].name="dcbst"         ; /*dcbst        */
  op_1f_subfunc_tbl[0x037].func=op_1f_037_func ; op_1f_subfunc_tbl[0x037].name="lwzux"         ; /*lwzux        */
  op_1f_subfunc_tbl[0x03c].func=op_1f_03c_func ; op_1f_subfunc_tbl[0x03c].name="andc"          ; /*andcx        */
  op_1f_subfunc_tbl[0x04b].func=op_1f_04b_func ; op_1f_subfunc_tbl[0x04b].name="mulhw"         ; /*mulhwx       */
  op_1f_subfunc_tbl[0x052].func=op_1f_052_func ; op_1f_subfunc_tbl[0x052].name="mtsrd"         ; /*mtsrd(*2,*3) */
  op_1f_subfunc_tbl[0x053].func=op_1f_053_func ; op_1f_subfunc_tbl[0x053].name="mfmsr"         ; /*mfmsr(*2)    */
  op_1f_subfunc_tbl[0x056].func=op_1f_056_func ; op_1f_subfunc_tbl[0x056].name="dcbf"          ; /*dcbf         */
  op_1f_subfunc_tbl[0x057].func=op_1f_057_func ; op_1f_subfunc_tbl[0x057].name="lbzx"          ; /*lbzx         */
  op_1f_subfunc_tbl[0x068].func=op_1f_068_func ; op_1f_subfunc_tbl[0x068].name="neg"           ; /*negx         */
  op_1f_subfunc_tbl[0x072].func=op_1f_072_func ; op_1f_subfunc_tbl[0x072].name="mtsrdin"       ; /*mtsrdin(*23) */
  op_1f_subfunc_tbl[0x077].func=op_1f_077_func ; op_1f_subfunc_tbl[0x077].name="lbzux"         ; /*lbzux        */
  op_1f_subfunc_tbl[0x07c].func=op_1f_07c_func ; op_1f_subfunc_tbl[0x07c].name="nor"           ; /*norx         */
  op_1f_subfunc_tbl[0x088].func=op_1f_088_func ; op_1f_subfunc_tbl[0x088].name="subfe"         ; /*subfex       */
  op_1f_subfunc_tbl[0x08a].func=op_1f_08a_func ; op_1f_subfunc_tbl[0x08a].name="adde"          ; /*addex        */
  op_1f_subfunc_tbl[0x090].func=op_1f_090_func ; op_1f_subfunc_tbl[0x090].name="mtcrf"         ; /*mtcrf        */
  op_1f_subfunc_tbl[0x092].func=op_1f_092_func ; op_1f_subfunc_tbl[0x092].name="mtmsr"         ; /*mtmsr(*2,*3) */
  op_1f_subfunc_tbl[0x096].func=op_1f_096_func ; op_1f_subfunc_tbl[0x096].name="stwcx"         ; /*stwcx.       */
  op_1f_subfunc_tbl[0x097].func=op_1f_097_func ; op_1f_subfunc_tbl[0x097].name="stwx"          ; /*stwx         */
  op_1f_subfunc_tbl[0x0b7].func=op_1f_0b7_func ; op_1f_subfunc_tbl[0x0b7].name="stwux"         ; /*stwux        */
  op_1f_subfunc_tbl[0x0c8].func=op_1f_0c8_func ; op_1f_subfunc_tbl[0x0c8].name="subfze"        ; /*subfzex      */
  op_1f_subfunc_tbl[0x0ca].func=op_1f_0ca_func ; op_1f_subfunc_tbl[0x0ca].name="addze"         ; /*addzex       */
  op_1f_subfunc_tbl[0x0d2].func=op_1f_0d2_func ; op_1f_subfunc_tbl[0x0d2].name="mtsr"          ; /*mtsr(*2,*3)  */
  op_1f_subfunc_tbl[0x0d7].func=op_1f_0d7_func ; op_1f_subfunc_tbl[0x0d7].name="stbx"          ; /*stbx         */
  op_1f_subfunc_tbl[0x0e8].func=op_1f_0e8_func ; op_1f_subfunc_tbl[0x0e8].name="subfme"        ; /*subfmex      */
  op_1f_subfunc_tbl[0x0ea].func=op_1f_0ea_func ; op_1f_subfunc_tbl[0x0ea].name="addme"         ; /*addmex       */
  op_1f_subfunc_tbl[0x0eb].func=op_1f_0eb_func ; op_1f_subfunc_tbl[0x0eb].name="mullw"         ; /*mullwx       */
  op_1f_subfunc_tbl[0x0f2].func=op_1f_0f2_func ; op_1f_subfunc_tbl[0x0f2].name="mtsrin"        ; /*mtsrin(*2,3) */
  op_1f_subfunc_tbl[0x0f6].func=op_1f_0f6_func ; op_1f_subfunc_tbl[0x0f6].name="dcbtst"        ; /*dcbtst       */
  op_1f_subfunc_tbl[0x0f7].func=op_1f_0f7_func ; op_1f_subfunc_tbl[0x0f7].name="stbux"         ; /*stbux        */
  op_1f_subfunc_tbl[0x10a].func=op_1f_10a_func ; op_1f_subfunc_tbl[0x10a].name="add"           ; /*addx         */
  op_1f_subfunc_tbl[0x116].func=op_1f_116_func ; op_1f_subfunc_tbl[0x116].name="dcbt"          ; /*dcbt         */
  op_1f_subfunc_tbl[0x117].func=op_1f_117_func ; op_1f_subfunc_tbl[0x117].name="lhzx"          ; /*lhzx         */
  op_1f_subfunc_tbl[0x11c].func=op_1f_11c_func ; op_1f_subfunc_tbl[0x11c].name="eqv"           ; /*eqvx         */
  op_1f_subfunc_tbl[0x132].func=op_1f_132_func ; op_1f_subfunc_tbl[0x132].name="tlbie"         ; /*tlbie(*2,4)  */
  op_1f_subfunc_tbl[0x136].func=op_1f_136_func ; op_1f_subfunc_tbl[0x136].name="eciwx"         ; /*eciwx        */
  op_1f_subfunc_tbl[0x137].func=op_1f_137_func ; op_1f_subfunc_tbl[0x137].name="lhzux"         ; /*lhzux        */
  op_1f_subfunc_tbl[0x13c].func=op_1f_13c_func ; op_1f_subfunc_tbl[0x13c].name="xor"           ; /*xorx         */
  op_1f_subfunc_tbl[0x153].func=op_1f_153_func ; op_1f_subfunc_tbl[0x153].name="mfspr"         ; /*mfspr(*5)    */
  op_1f_subfunc_tbl[0x157].func=op_1f_157_func ; op_1f_subfunc_tbl[0x157].name="lhax"          ; /*lhax         */
  op_1f_subfunc_tbl[0x172].func=op_1f_172_func ; op_1f_subfunc_tbl[0x172].name="tlbia"         ; /*tlbia(2,4,7) */
  op_1f_subfunc_tbl[0x173].func=op_1f_173_func ; op_1f_subfunc_tbl[0x173].name="mftb"          ; /*mftb         */
  op_1f_subfunc_tbl[0x177].func=op_1f_177_func ; op_1f_subfunc_tbl[0x177].name="lhaux"         ; /*lhaux        */
  op_1f_subfunc_tbl[0x197].func=op_1f_197_func ; op_1f_subfunc_tbl[0x197].name="sthx"          ; /*sthx         */
  op_1f_subfunc_tbl[0x19c].func=op_1f_19c_func ; op_1f_subfunc_tbl[0x19c].name="orc"           ; /*orcx         */
  op_1f_subfunc_tbl[0x1b6].func=op_1f_1b6_func ; op_1f_subfunc_tbl[0x1b6].name="ecowx"         ; /*ecowx        */
  op_1f_subfunc_tbl[0x1b7].func=op_1f_1b7_func ; op_1f_subfunc_tbl[0x1b7].name="sthux"         ; /*sthux        */
  op_1f_subfunc_tbl[0x1bc].func=op_1f_1bc_func ; op_1f_subfunc_tbl[0x1bc].name="or"            ; /*orx          */
  op_1f_subfunc_tbl[0x1cb].func=op_1f_1cb_func ; op_1f_subfunc_tbl[0x1cb].name="divwu"         ; /*divwux       */
  op_1f_subfunc_tbl[0x1d3].func=op_1f_1d3_func ; op_1f_subfunc_tbl[0x1d3].name="mtspr"         ; /*mtspr(*5)    */
  op_1f_subfunc_tbl[0x1d6].func=op_1f_1d6_func ; op_1f_subfunc_tbl[0x1d6].name="dcbi"          ; /*dcbi(*2)     */
  op_1f_subfunc_tbl[0x1dc].func=op_1f_1dc_func ; op_1f_subfunc_tbl[0x1dc].name="nand"          ; /*nandx        */
  op_1f_subfunc_tbl[0x1eb].func=op_1f_1eb_func ; op_1f_subfunc_tbl[0x1eb].name="divw"          ; /*divwx        */
  op_1f_subfunc_tbl[0x200].func=op_1f_200_func ; op_1f_subfunc_tbl[0x200].name="mcrxr"         ; /*mcrxr        */
  op_1f_subfunc_tbl[0x208].func=op_1f_208_func ; op_1f_subfunc_tbl[0x208].name="subfco"        ; /*subfcox      */
  op_1f_subfunc_tbl[0x20a].func=op_1f_20a_func ; op_1f_subfunc_tbl[0x20a].name="addco"         ; /*addcox       */
  op_1f_subfunc_tbl[0x215].func=op_1f_215_func ; op_1f_subfunc_tbl[0x215].name="lswx"          ; /*lswx(*6)     */
  op_1f_subfunc_tbl[0x216].func=op_1f_216_func ; op_1f_subfunc_tbl[0x216].name="lwbrx"         ; /*lwbrx        */
  op_1f_subfunc_tbl[0x217].func=op_1f_217_func ; op_1f_subfunc_tbl[0x217].name="lfsx"          ; /*lfsx         */
  op_1f_subfunc_tbl[0x218].func=op_1f_218_func ; op_1f_subfunc_tbl[0x218].name="srw"           ; /*srwx         */
  op_1f_subfunc_tbl[0x228].func=op_1f_228_func ; op_1f_subfunc_tbl[0x228].name="subfo"         ; /*subfox       */
  op_1f_subfunc_tbl[0x236].func=op_1f_236_func ; op_1f_subfunc_tbl[0x236].name="tlbsync"       ; /*tlbsync(2,4) */
  op_1f_subfunc_tbl[0x237].func=op_1f_237_func ; op_1f_subfunc_tbl[0x237].name="lfsux"         ; /*lfsux        */
  op_1f_subfunc_tbl[0x253].func=op_1f_253_func ; op_1f_subfunc_tbl[0x253].name="mfsr"          ; /*mfsr(2,3)    */
  op_1f_subfunc_tbl[0x255].func=op_1f_255_func ; op_1f_subfunc_tbl[0x255].name="lswi"          ; /*lswi(*6)     */
  op_1f_subfunc_tbl[0x256].func=op_1f_256_func ; op_1f_subfunc_tbl[0x256].name="sync"          ; /*sync         */
  op_1f_subfunc_tbl[0x257].func=op_1f_257_func ; op_1f_subfunc_tbl[0x257].name="lfdx"          ; /*lfdx         */
  op_1f_subfunc_tbl[0x268].func=op_1f_268_func ; op_1f_subfunc_tbl[0x268].name="nego"          ; /*negox        */
  op_1f_subfunc_tbl[0x277].func=op_1f_277_func ; op_1f_subfunc_tbl[0x277].name="lfdux"         ; /*lfdux        */
  op_1f_subfunc_tbl[0x288].func=op_1f_288_func ; op_1f_subfunc_tbl[0x288].name="subfeo"        ; /*subfeox      */
  op_1f_subfunc_tbl[0x28a].func=op_1f_28a_func ; op_1f_subfunc_tbl[0x28a].name="addeo"         ; /*addeox       */
  op_1f_subfunc_tbl[0x293].func=op_1f_293_func ; op_1f_subfunc_tbl[0x293].name="mfsrin"        ; /*mfsrin(2,3)  */
  op_1f_subfunc_tbl[0x295].func=op_1f_295_func ; op_1f_subfunc_tbl[0x295].name="stswx"         ; /*stswx(*6)    */
  op_1f_subfunc_tbl[0x296].func=op_1f_296_func ; op_1f_subfunc_tbl[0x296].name="stwbrx"        ; /*stwbrx       */
  op_1f_subfunc_tbl[0x297].func=op_1f_297_func ; op_1f_subfunc_tbl[0x297].name="stfsx"         ; /*stfsx        */
  op_1f_subfunc_tbl[0x2b7].func=op_1f_2b7_func ; op_1f_subfunc_tbl[0x2b7].name="stfsux"        ; /*stfsux       */
  op_1f_subfunc_tbl[0x2c8].func=op_1f_2c8_func ; op_1f_subfunc_tbl[0x2c8].name="subfzeo"       ; /*subfzeox     */
  op_1f_subfunc_tbl[0x2ca].func=op_1f_2ca_func ; op_1f_subfunc_tbl[0x2ca].name="addzeo"        ; /*addzeox      */
  op_1f_subfunc_tbl[0x2d5].func=op_1f_2d5_func ; op_1f_subfunc_tbl[0x2d5].name="stswi"         ; /*stswi(*6)    */
  op_1f_subfunc_tbl[0x2d7].func=op_1f_2d7_func ; op_1f_subfunc_tbl[0x2d7].name="stfdx"         ; /*stfdx        */
  op_1f_subfunc_tbl[0x2e8].func=op_1f_2e8_func ; op_1f_subfunc_tbl[0x2e8].name="subfmeo"       ; /*subfmeox     */
  op_1f_subfunc_tbl[0x2ea].func=op_1f_2ea_func ; op_1f_subfunc_tbl[0x2ea].name="addmeo"        ; /*addmeox      */
  op_1f_subfunc_tbl[0x2eb].func=op_1f_2eb_func ; op_1f_subfunc_tbl[0x2eb].name="mullwo"        ; /*mullwox      */
  op_1f_subfunc_tbl[0x2f6].func=op_1f_2f6_func ; op_1f_subfunc_tbl[0x2f6].name="dcba"          ; /*dcba(*4,7)   */
  op_1f_subfunc_tbl[0x2f7].func=op_1f_2f7_func ; op_1f_subfunc_tbl[0x2f7].name="stfdux"        ; /*stfdux       */
  op_1f_subfunc_tbl[0x30a].func=op_1f_30a_func ; op_1f_subfunc_tbl[0x30a].name="addo"          ; /*addox        */
  op_1f_subfunc_tbl[0x316].func=op_1f_316_func ; op_1f_subfunc_tbl[0x316].name="lhbrx"         ; /*lhbrx        */
  op_1f_subfunc_tbl[0x318].func=op_1f_318_func ; op_1f_subfunc_tbl[0x318].name="sraw"          ; /*srawx        */
  op_1f_subfunc_tbl[0x338].func=op_1f_338_func ; op_1f_subfunc_tbl[0x338].name="srawi"         ; /*srawix       */
  op_1f_subfunc_tbl[0x356].func=op_1f_356_func ; op_1f_subfunc_tbl[0x356].name="eieio"         ; /*eieio        */
  op_1f_subfunc_tbl[0x396].func=op_1f_396_func ; op_1f_subfunc_tbl[0x396].name="sthbrx"        ; /*sthbrx       */
  op_1f_subfunc_tbl[0x39a].func=op_1f_39a_func ; op_1f_subfunc_tbl[0x39a].name="extshx"        ; /*extshx       */
  op_1f_subfunc_tbl[0x3ba].func=op_1f_3ba_func ; op_1f_subfunc_tbl[0x3ba].name="extsbx"        ; /*extsbx       */
  op_1f_subfunc_tbl[0x3cb].func=op_1f_3cb_func ; op_1f_subfunc_tbl[0x3cb].name="divwuo"        ; /*divwuox      */
  op_1f_subfunc_tbl[0x3d6].func=op_1f_3d6_func ; op_1f_subfunc_tbl[0x3d6].name="icbi"          ; /*icbi         */
  op_1f_subfunc_tbl[0x3d7].func=op_1f_3d7_func ; op_1f_subfunc_tbl[0x3d7].name="stfiwx"        ; /*stfiwx(*4)   */
  op_1f_subfunc_tbl[0x3eb].func=op_1f_3eb_func ; op_1f_subfunc_tbl[0x3eb].name="divwo"         ; /*divwox       */
  op_1f_subfunc_tbl[0x3f6].func=op_1f_3f6_func ; op_1f_subfunc_tbl[0x3f6].name="dcbz"          ; /*dcbz         */

  /*** 0x7cn Tu߃Zbg *****************/
  for( i=0 ; i<TBL_SIZE_bit27to30 ; i++ ){
    op_3b_subfunc_tbl[i].func =op_unknown_func ;
    op_3b_subfunc_tbl[i].count=0 ;
    op_3b_subfunc_tbl[i].name ="" ;
  }
  op_3b_subfunc_tbl[0x002].func=op_3b_002_func ; op_3b_subfunc_tbl[0x002].name="fdivs"         ; /* fdivsx */
  op_3b_subfunc_tbl[0x004].func=op_3b_004_func ; op_3b_subfunc_tbl[0x004].name="fsubs"         ; /* fsubsx */
  op_3b_subfunc_tbl[0x005].func=op_3b_005_func ; op_3b_subfunc_tbl[0x005].name="fadds"         ; /* faddsx */
  op_3b_subfunc_tbl[0x008].func=op_3b_008_func ; op_3b_subfunc_tbl[0x008].name="fres"          ; /* fresx */
  op_3b_subfunc_tbl[0x009].func=op_3b_009_func ; op_3b_subfunc_tbl[0x009].name="fmuls"         ; /* fmulsx */
  op_3b_subfunc_tbl[0x00c].func=op_3b_00c_func ; op_3b_subfunc_tbl[0x00c].name="fmsubs"        ; /* fmsubsx */
  op_3b_subfunc_tbl[0x00d].func=op_3b_00d_func ; op_3b_subfunc_tbl[0x00d].name="fmadds"        ; /* fmaddsx */
  op_3b_subfunc_tbl[0x00e].func=op_3b_00e_func ; op_3b_subfunc_tbl[0x00e].name="fnmsubs"       ; /* fnmsubsx */
  op_3b_subfunc_tbl[0x00f].func=op_3b_00f_func ; op_3b_subfunc_tbl[0x00f].name="fnmadds"       ; /* fnmaddsx */
  
  /*** 0x7fn Tu߃Zbg bit26==0 *****************/
  for( i=0 ; i<TBL_SIZE_bit21to30 ; i++ ){
    op_3f_subfunc0_tbl[i].func =op_unknown_func ;
    op_3f_subfunc0_tbl[i].count=0 ;
    op_3f_subfunc0_tbl[i].name ="" ;
  }
  op_3f_subfunc0_tbl[0x000].func=op_3f_000_func ; op_3f_subfunc0_tbl[0x000].name="fcmpu"       ; /* fcmpu */
  op_3f_subfunc0_tbl[0x00c].func=op_3f_00c_func ; op_3f_subfunc0_tbl[0x00c].name="frsp"        ; /* frspx */
  op_3f_subfunc0_tbl[0x00f].func=op_3f_00f_func ; op_3f_subfunc0_tbl[0x00f].name="fctiwz"      ; /* fctiwzx */
  op_3f_subfunc0_tbl[0x020].func=op_3f_020_func ; op_3f_subfunc0_tbl[0x020].name="fcmpo"       ; /* fcmpo */
  op_3f_subfunc0_tbl[0x028].func=op_3f_028_func ; op_3f_subfunc0_tbl[0x028].name="fneg"        ; /* fnegx */
  op_3f_subfunc0_tbl[0x048].func=op_3f_048_func ; op_3f_subfunc0_tbl[0x048].name="fmr"         ; /* fmrx */
  op_3f_subfunc0_tbl[0x088].func=op_3f_088_func ; op_3f_subfunc0_tbl[0x088].name="fnabs"       ; /* fnabsx */
  op_3f_subfunc0_tbl[0x108].func=op_3f_108_func ; op_3f_subfunc0_tbl[0x108].name="fabs"        ; /* fabsx */

  /*** 0x7fn Tu߃Zbg bit26==1 *****************/
  for( i=0 ; i<TBL_SIZE_bit27to30 ; i++ ){
    op_3f_subfunc1_tbl[i].func =op_unknown_func ;
    op_3f_subfunc1_tbl[i].count=0 ;
    op_3f_subfunc1_tbl[i].name ="" ;
  }
  op_3f_subfunc1_tbl[0x2].func=op_3f_x12_func ; op_3f_subfunc1_tbl[0x2].name="fdiv"            ; /* fdivx */
  op_3f_subfunc1_tbl[0x4].func=op_3f_x14_func ; op_3f_subfunc1_tbl[0x4].name="fsub"            ; /* fsubx */
  op_3f_subfunc1_tbl[0x5].func=op_3f_x15_func ; op_3f_subfunc1_tbl[0x5].name="fadd"            ; /* faddx */
  op_3f_subfunc1_tbl[0x9].func=op_3f_x19_func ; op_3f_subfunc1_tbl[0x9].name="fmul"            ; /* fmulx */
  op_3f_subfunc1_tbl[0xc].func=op_3f_x1c_func ; op_3f_subfunc1_tbl[0xc].name="fmsub"           ; /* fmsubx */
  op_3f_subfunc1_tbl[0xd].func=op_3f_x1d_func ; op_3f_subfunc1_tbl[0xd].name="fmadd"           ; /* fmaddx */
  op_3f_subfunc1_tbl[0xe].func=op_3f_x1e_func ; op_3f_subfunc1_tbl[0xe].name="fnmsub"          ; /* fnmsubx */
  op_3f_subfunc1_tbl[0xf].func=op_3f_x1f_func ; op_3f_subfunc1_tbl[0xf].name="fnmadd"          ; /* fnmaddx */

  return(0) ;
}

int reset_exec_op_count()
{
  int i ;
  for( i=0 ; i<TBL_SIZE_bit00to05 ; i++ ){
    op_func_tbl[i].count=0 ;
  }
  for( i=0 ; i<TBL_SIZE_bit21to30 ; i++ ){
    op_13_subfunc_tbl[i].count=0 ;
  }
  for( i=0 ; i<TBL_SIZE_bit21to30 ; i++ ){
    op_1f_subfunc_tbl[i].count=0 ;
  }
  for( i=0 ; i<TBL_SIZE_bit27to30 ; i++ ){
    op_3b_subfunc_tbl[i].count=0 ;
  }
  for( i=0 ; i<TBL_SIZE_bit21to30 ; i++ ){
    op_3f_subfunc0_tbl[i].count=0 ;
  }
  for( i=0 ; i<TBL_SIZE_bit27to30 ; i++ ){
    op_3f_subfunc1_tbl[i].count=0 ;
  }
  return(0) ;
}

int op_exec( struct MACHINE_RESOURCE *mres , int mode ) /* top of instruction decode */
{
  unsigned int inst0to5 ;

  if( (mres->pc % 4) !=0 ) return( (PC_BOUNDARY_ERROR|OPFETCH_FLAG) ) ;

  ifetchu4b(mres->inst,mres->pc) ;

  inst0to5=(mres->inst & 0xfc000000)>>26 ;
  if( DO_EXEC_DIS(mode) ){
    SYSMSG("%08x : %08x    %s",
	   mres->pc,
	   mres->inst,
	   op_func_tbl[inst0to5].name) ;
  }
  if( DO_EXEC_INST(mode) ){
    op_func_tbl[inst0to5].count++ ;
  }
  return( op_func_tbl[inst0to5].func( mres, mode ) ) ;
}

